/* -*-c++-*- osgVisual - Copyright (C) 2009-2011 Torben Dannhauer
 *
 * This library is based on OpenSceneGraph, open source and may be redistributed and/or modified under 
 * the terms of the OpenSceneGraph Public License (OSGPL) version 0.0 or
 * (at your option) any later version.  The full license is in LICENSE file
 * included with this distribution, and on the openscenegraph.org website.
 *
 * osgVisual requires for some proprietary modules a license from the correspondig manufacturer.
 * You have to aquire licenses for all used proprietary modules.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * OpenSceneGraph Public License for more details.
*/

#include "ModificationManager.h"

#define USE_TERRAIN_PROTO_WORKAROUND USE_TERRAIN_PROTO_WORKAROUND


void ModificationManager::addTerrainToManage(osgTerrain::Terrain* terrain)
{
	if(terrain)
		managedTerrain.push_back(terrain);
}

bool ModificationManager::removeTerrainToManage(osgTerrain::Terrain* terrain)
{
	for(unsigned int i=0;i<managedTerrain.size();i++)
	{
		if(managedTerrain[i] == terrain)
		{
			managedTerrain.erase(managedTerrain.begin()+i);
			return true;
		}
	}
	return false;
}

void ModificationManager::setGeometryTechniquePrototype( osgTerrain::GeometryTechnique* geomTechnique, osgTerrain::Terrain* terrain )
{
	if(!geomTechnique)	// Remove the installed geometry technique
	{
		terrain->setTerrainTechniquePrototype( NULL );
#ifdef USE_TERRAIN_PROTO_WORKAROUND
		osgTerrain::TerrainTile::setTileLoadedCallback(NULL);
#endif
		return;
	}


	terrain->setTerrainTechniquePrototype( geomTechnique );
#ifdef USE_TERRAIN_PROTO_WORKAROUND
	osg::ref_ptr<osgTerrain::GeometryTechniquePrototypeWorkaroundTLC> tlcb = new osgTerrain::GeometryTechniquePrototypeWorkaroundTLC();
	osgTerrain::TerrainTile::setTileLoadedCallback(tlcb);
#endif


}

